/********************************************************/
/*  ntapi: Native API core library                      */
/*  Copyright (C) 2013--2017  Z. Gilboa                 */
/*  Released under GPLv2 and GPLv3; see COPYING.NTAPI.  */
/********************************************************/

#include <psxtypes/psxtypes.h>
#include <ntapi/nt_tty.h>
#include <ntapi/ntapi.h>
#include "ntapi_impl.h"

typedef struct _nt_tty_disconnect_msg {
	nt_port_message			header;
	struct {
		nt_tty_msg_info		ttyinfo;
	} data;
} nt_tty_disconnect_msg;

int32_t __stdcall __ntapi_tty_client_session_disconnect(void * hport)
{
	int32_t			status;
	nt_tty_disconnect_msg	msg;

	hport = hport ? hport :  __ntapi_internals()->hport_tty_session;

	__ntapi->tt_aligned_block_memset(
		&msg,0,sizeof(msg));

	msg.header.msg_type	= NT_LPC_NEW_MESSAGE;
	msg.header.data_size	= sizeof(msg.data);
	msg.header.msg_size	= sizeof(msg);
	msg.data.ttyinfo.opcode	= NT_TTY_CLIENT_SESSION_DISCONNECT;

	if ((status = __ntapi->zw_request_wait_reply_port(hport,&msg,&msg)))
		return status;

	return msg.data.ttyinfo.status;
}
